<?php
namespace BackOfficeOptimizer\Services;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use BackOfficeOptimizer\Libraries\JWT;


class Login{
    protected $loginProvider;
    protected $paramGeralProvider;
    protected $environment;
    protected $permissionProvider;

    public function __construct($loginProvider, $paramGeralProvider, $environment, $permissionProvider){
        $this->loginProvider = $loginProvider;
        $this->paramGeralProvider = $paramGeralProvider;
        $this->environment = $environment;
        $this->permissionProvider = $permissionProvider;
    }

    /**
     * Try to log in user using inputed username
     * and password.
     */
    public function doLogin(Request $request, Response $response){
        $userData = $request->getRow();
     
        $loginResult = $this->loginProvider->doLogin($userData);
        $paramGeralData = $this->paramGeralProvider->getParamGeral($userData);
        $response->addDataSet(new DataSet('loginData', $loginResult));

        
        if($loginResult && sizeof($loginResult)){
            $per = $this->permissionProvider->getUserPermissions($loginResult[0]['CDOPERADOR'], $loginResult[0]['NRORG']);
            $token = JWT::generateToken(array(
                "CDOPERADOR" => $loginResult[0]['CDOPERADOR'],
                "NRORG" => $loginResult[0]['NRORG'],
                "GRANT_ALL" => $per["grantAll"],
                "SCOPES" =>  $per["scopes"]
            ));
            
            $canAccessPermissionManagement = $this->permissionProvider->getPermissionManagementStatus($loginResult[0]['NRORG']);
            $response->addDataSet(new DataSet('canAccessPermissionManagement', [$canAccessPermissionManagement]));
            $response->addDataSet(new DataSet('paramGeralData', $paramGeralData));
            $response->addDataSet(new DataSet('token', [$token]));
            $response->addDataSet(new DataSet('permissions', $per));
        }
    }

    public function testConnection(){}
}
